
BPPlatform subclass: #BPVWPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-VisualWorks'!

!BPVWPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 15:10'!
byteArrayFromBase64String: aString

	^ByteArray fromBase64String: aString! !

!BPVWPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 15:10'!
check! !

!BPVWPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 15:10'!
fileDelete: fileName

	fileName asFilename delete! !

!BPVWPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 15:10'!
fileWrite: fileName contents: aString

	| fileStream |
	fileStream := fileName asFilename writeStream.
	(aString isKindOf: ByteArray) ifTrue: [ fileStream binary ].
	fileStream
		nextPutAll: aString;
		close.
	^fileName asFilename asAbsoluteFilename asString! !

!BPVWPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 15:10'!
handleRequest: aBlock

	| response |
	response := aBlock on: Net.HttpException do: [:ex | ex parameter].
	^(BPHttpResponse new)
		httpStatus: response statusLine code asNumber;
		headers: response header registry;
		contents: response contents;
		yourself! !

!BPVWPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 15:10'!
httpClient
	^Net.HttpClient new timeout: 30000.! !

!BPVWPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 15:10'!
httpDelete: url

	^self handleRequest: [self httpClient delete: url]! !

!BPVWPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 15:10'!
httpGet: url

	^self handleRequest: [self httpClient get: url]! !

!BPVWPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 15:10'!
httpPost: url data: data timeout: timeout

	| postRequest client |
	client := self httpClient.
	timeout ifNotNil: [:x | client timeout: x * 1000].
	Net.MimeTypeDescriptor new contentType: 'application/json'.
	postRequest := Net.HttpRequest method: 'POST' url: url.
	postRequest contentType: 'application/json'.
	postRequest acceptEncoding: 'utf-8'.
	postRequest contentEncoding: 'utf-8'.
	postRequest byteSource: (data asByteArrayEncoding: #utf8) readStream.
	postRequest url: url.
	^self handleRequest: [client executeRequest: postRequest]! !

!BPVWPlatform methodsFor: 'facade' stamp: 'haerle 8/20/2014 09:25'!
isMacOSX

	^InputManager isMacOSX! !

!BPVWPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 15:10'!
jsonRead: aString 
	^Javascript.JSJsonParser parse: aString! !

!BPVWPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 15:10'!
jsonWrite: anObject

	| stream |
	stream := WriteStream on: String new.
	anObject jsonWriteOn: stream.
	^stream contents! !

!BPVWPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 15:10'!
name
	^'VW'! !

!BPVWPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 15:10'!
pngImageFromByteArray: aByteArray

	^(PNGImageReader new from: aByteArray readStream) image! !

!BPVWPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 15:10'!
port
	^7777.! !

!BPVWPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 15:10'!
registrationName
	^'dashboard'.! !

!BPVWPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 15:10'!
signalException: exception

	^exception raiseSignal! !

!BPVWPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 15:10'!
statusCodeFromResponse: response

	^response code asNumber! !
